/*
"This software contains source code provided by NVIDIA Corporation."
Copyright NVIDIA Corporation 2007

converted for use with vvvv by desaxismundi

http://vvvv.org/tiki-index.php?page=UserPageDesaxismundi
http://vvvv.org/tiki-index.php?page=desaxismundi_Shaders
*/
// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------

float4x4 tWVP : WorldViewProjection;

//light properties
float4 NearColor : COLOR <string UIName =  "Foreground Color";> = {1.0, 1.0, 1.0, 1.0};
float4 FarColor : COLOR <string UIName =  "Background Color";> = {0.0, 0.0, 0.0, 1.0};

float Hither <string UIName =  "near distance";
> = 1.0;

float Yon <string UIName =  "far distance";
> = 3.0;

float Gamma <string UIName =  "adjust rolloff";
    float UIMin = 0.1;
    float UIMax = 5.0;
    float UIStep = 0.05;
> = 1.0;


/* data passed from vertex shader to pixel shader */
struct vertexOutput {
    float4 HPosition	: POSITION;
    float4 Color	: COLOR0;
};

/*********** vertex shader ******/

vertexOutput VS(
             float3 Position	: POSITION,
             float4 UV		: TEXCOORD0)
{
    vertexOutput OUT;
    float4 Po = float4(Position.x,Position.y,Position.z,1.0);
    float4 hpos = mul(Po, tWVP);
    float dl = (hpos.z-Hither)/(Yon-Hither);
    dl = min(dl,1.0);
    dl = max(dl,0.0);
    dl = pow(dl,Gamma);
    OUT.Color = lerp(NearColor,FarColor,dl);
    OUT.HPosition = hpos;
    return OUT;
}

/*************/

technique Depth
{
	pass p0
        {
		VertexShader = compile vs_1_1 VS();

		// no pixel shader
	}
}
